' DEVICE_L.BAS

Option Explicit

Dim FatalFlag As Integer
Dim Code As Integer

Sub Aborting ()
  Dim Code As Integer
  DEVICE.Print "Fatal Error, Aborting..."
  Code = SioDone(ThePort)
  End
End Sub

Sub GetIncoming ()
  Dim Buffer As String * 1024
  Dim Count As Integer
  Count = SioGets(ThePort, Buffer, 1024)
  If Count > 0 Then
    DEVICE.editMessage.Text = DEVICE.editMessage.Text + Left$(Buffer, Count)
  End If
End Sub

Sub GoOffLine ()
  Dim Code As Integer
  OnLineFlag = 0
  DEVICE.buttonSend.Enabled = False
  'shut down port
  Code = SioDone(ThePort)
End Sub

Sub GoOnLine ()
  Dim NL As String
  Dim RxQueSize As Integer
  Dim TxQueSize As Integer
  If OnLineFlag Then
    Exit Sub
  End If
  NL = Chr$(13) + Chr$(10)
  'reset the port (1024 byte RX buffer & 256 byte TX buffer)
  RxQueSize = 1024
  TxQueSize = 256
  Code = SioReset(ThePort, RxQueSize, TxQueSize)
  If Code < 0 Then
    Call SayError(DEVICE, Code)
    Exit Sub
  End If
  'set baud rate
  Code = SioBaud(ThePort, TheBaudCode)
  'call Aborting() if detect error after resetting port
  DEVICE.editMessage.Text = DEVICE.editMessage.Text + NL + "COM" + LTrim$(Str$(1 + ThePort)) + " reset"
  'set DTR & RTS
  Code = SioDTR(ThePort, Asc("S"))
  Code = SioRTS(ThePort, Asc("S"))
  DEVICE.editMessage.Text = DEVICE.editMessage.Text + NL + "DTR and RTS are set"
  ' check for DSR
  If SioDSR(ThePort) Then
    DEVICE.editMessage.Text = DEVICE.editMessage.Text + NL + "DSR is set"
  Else
    DEVICE.editMessage.Text = DEVICE.editMessage.Text + NL + "DSR is clear"
  End If
  ' set parms
  Code = SioParms(ThePort, NoParity, OneStopBit, WordLength8)
  DEVICE.buttonSend.Enabled = True
  ' ready to roll
  DEVICE.editMessage.Text = DEVICE.editMessage.Text + NL + "Push 'Send String' above to send string" + NL
  ' we're online !
  OnLineFlag = 1
End Sub

Sub SetBaud ()
Dim Code As Integer
'Baudrate can be changed while running
Code = SioBaud(ThePort, TheBaudCode)
End Sub

Sub ShowConfig ()
  Dim A As String
  Dim B As String
  Dim C As String
  If OnLineFlag Then
    A = " (Online)"
  Else
    A = " (Offline)"
  End If
  B = "COM" + LTrim$(Str$(ThePort + 1))
  C = " @ " + BaudRateTable(TheBaudCode) + " "
  DEVICE.Caption = "DEVICE: " + B + C + A
End Sub

